<?php
/**
 * Theme storage manipulations
 *
 * @package KICKER
 * @since KICKER 1.0
 */

// Disable direct call
if ( ! defined( 'ABSPATH' ) ) {
	exit; }

// Get theme variable
if ( ! function_exists( 'kicker_storage_get' ) ) {
	function kicker_storage_get( $var_name, $default = '' ) {
		global $KICKER_STORAGE;
		return isset( $KICKER_STORAGE[ $var_name ] ) ? $KICKER_STORAGE[ $var_name ] : $default;
	}
}

// Set theme variable
if ( ! function_exists( 'kicker_storage_set' ) ) {
	function kicker_storage_set( $var_name, $value ) {
		global $KICKER_STORAGE;
		$KICKER_STORAGE[ $var_name ] = $value;
	}
}

// Check if theme variable is empty
if ( ! function_exists( 'kicker_storage_empty' ) ) {
	function kicker_storage_empty( $var_name, $key = '', $key2 = '' ) {
		global $KICKER_STORAGE;
		if ( ! empty( $key ) && ! empty( $key2 ) ) {
			return empty( $KICKER_STORAGE[ $var_name ][ $key ][ $key2 ] );
		} elseif ( ! empty( $key ) ) {
			return empty( $KICKER_STORAGE[ $var_name ][ $key ] );
		} else {
			return empty( $KICKER_STORAGE[ $var_name ] );
		}
	}
}

// Check if theme variable is set
if ( ! function_exists( 'kicker_storage_isset' ) ) {
	function kicker_storage_isset( $var_name, $key = '', $key2 = '' ) {
		global $KICKER_STORAGE;
		if ( ! empty( $key ) && ! empty( $key2 ) ) {
			return isset( $KICKER_STORAGE[ $var_name ][ $key ][ $key2 ] );
		} elseif ( ! empty( $key ) ) {
			return isset( $KICKER_STORAGE[ $var_name ][ $key ] );
		} else {
			return isset( $KICKER_STORAGE[ $var_name ] );
		}
	}
}

// Delete theme variable
if ( ! function_exists( 'kicker_storage_unset' ) ) {
	function kicker_storage_unset( $var_name, $key = '', $key2 = '' ) {
		global $KICKER_STORAGE;
		if ( ! empty( $key ) && ! empty( $key2 ) ) {
			unset( $KICKER_STORAGE[ $var_name ][ $key ][ $key2 ] );
		} elseif ( ! empty( $key ) ) {
			unset( $KICKER_STORAGE[ $var_name ][ $key ] );
		} else {
			unset( $KICKER_STORAGE[ $var_name ] );
		}
	}
}

// Inc/Dec theme variable with specified value
if ( ! function_exists( 'kicker_storage_inc' ) ) {
	function kicker_storage_inc( $var_name, $value = 1 ) {
		global $KICKER_STORAGE;
		if ( empty( $KICKER_STORAGE[ $var_name ] ) ) {
			$KICKER_STORAGE[ $var_name ] = 0;
		}
		$KICKER_STORAGE[ $var_name ] += $value;
	}
}

// Concatenate theme variable with specified value
if ( ! function_exists( 'kicker_storage_concat' ) ) {
	function kicker_storage_concat( $var_name, $value ) {
		global $KICKER_STORAGE;
		if ( empty( $KICKER_STORAGE[ $var_name ] ) ) {
			$KICKER_STORAGE[ $var_name ] = '';
		}
		$KICKER_STORAGE[ $var_name ] .= $value;
	}
}

// Get array (one or two dim) element
if ( ! function_exists( 'kicker_storage_get_array' ) ) {
	function kicker_storage_get_array( $var_name, $key, $key2 = '', $default = '' ) {
		global $KICKER_STORAGE;
		if ( empty( $key2 ) ) {
			return ! empty( $var_name ) && ! empty( $key ) && isset( $KICKER_STORAGE[ $var_name ][ $key ] ) ? $KICKER_STORAGE[ $var_name ][ $key ] : $default;
		} else {
			return ! empty( $var_name ) && ! empty( $key ) && isset( $KICKER_STORAGE[ $var_name ][ $key ][ $key2 ] ) ? $KICKER_STORAGE[ $var_name ][ $key ][ $key2 ] : $default;
		}
	}
}

// Set array element
if ( ! function_exists( 'kicker_storage_set_array' ) ) {
	function kicker_storage_set_array( $var_name, $key, $value ) {
		global $KICKER_STORAGE;
		if ( ! isset( $KICKER_STORAGE[ $var_name ] ) ) {
			$KICKER_STORAGE[ $var_name ] = array();
		}
		if ( '' === $key ) {
			$KICKER_STORAGE[ $var_name ][] = $value;
		} else {
			$KICKER_STORAGE[ $var_name ][ $key ] = $value;
		}
	}
}

// Set two-dim array element
if ( ! function_exists( 'kicker_storage_set_array2' ) ) {
	function kicker_storage_set_array2( $var_name, $key, $key2, $value ) {
		global $KICKER_STORAGE;
		if ( ! isset( $KICKER_STORAGE[ $var_name ] ) ) {
			$KICKER_STORAGE[ $var_name ] = array();
		}
		if ( ! isset( $KICKER_STORAGE[ $var_name ][ $key ] ) ) {
			$KICKER_STORAGE[ $var_name ][ $key ] = array();
		}
		if ( '' === $key2 ) {
			$KICKER_STORAGE[ $var_name ][ $key ][] = $value;
		} else {
			$KICKER_STORAGE[ $var_name ][ $key ][ $key2 ] = $value;
		}
	}
}

// Merge array elements
if ( ! function_exists( 'kicker_storage_merge_array' ) ) {
	function kicker_storage_merge_array( $var_name, $key, $value ) {
		global $KICKER_STORAGE;
		if ( ! isset( $KICKER_STORAGE[ $var_name ] ) ) {
			$KICKER_STORAGE[ $var_name ] = array();
		}
		if ( '' === $key ) {
			$KICKER_STORAGE[ $var_name ] = array_merge( $KICKER_STORAGE[ $var_name ], $value );
		} else {
			$KICKER_STORAGE[ $var_name ][ $key ] = array_merge( $KICKER_STORAGE[ $var_name ][ $key ], $value );
		}
	}
}

// Add array element after the key
if ( ! function_exists( 'kicker_storage_set_array_after' ) ) {
	function kicker_storage_set_array_after( $var_name, $after, $key, $value = '' ) {
		global $KICKER_STORAGE;
		if ( ! isset( $KICKER_STORAGE[ $var_name ] ) ) {
			$KICKER_STORAGE[ $var_name ] = array();
		}
		if ( is_array( $key ) ) {
			kicker_array_insert_after( $KICKER_STORAGE[ $var_name ], $after, $key );
		} else {
			kicker_array_insert_after( $KICKER_STORAGE[ $var_name ], $after, array( $key => $value ) );
		}
	}
}

// Add array element before the key
if ( ! function_exists( 'kicker_storage_set_array_before' ) ) {
	function kicker_storage_set_array_before( $var_name, $before, $key, $value = '' ) {
		global $KICKER_STORAGE;
		if ( ! isset( $KICKER_STORAGE[ $var_name ] ) ) {
			$KICKER_STORAGE[ $var_name ] = array();
		}
		if ( is_array( $key ) ) {
			kicker_array_insert_before( $KICKER_STORAGE[ $var_name ], $before, $key );
		} else {
			kicker_array_insert_before( $KICKER_STORAGE[ $var_name ], $before, array( $key => $value ) );
		}
	}
}

// Push element into array
if ( ! function_exists( 'kicker_storage_push_array' ) ) {
	function kicker_storage_push_array( $var_name, $key, $value ) {
		global $KICKER_STORAGE;
		if ( ! isset( $KICKER_STORAGE[ $var_name ] ) ) {
			$KICKER_STORAGE[ $var_name ] = array();
		}
		if ( '' === $key ) {
			array_push( $KICKER_STORAGE[ $var_name ], $value );
		} else {
			if ( ! isset( $KICKER_STORAGE[ $var_name ][ $key ] ) ) {
				$KICKER_STORAGE[ $var_name ][ $key ] = array();
			}
			array_push( $KICKER_STORAGE[ $var_name ][ $key ], $value );
		}
	}
}

// Pop element from array
if ( ! function_exists( 'kicker_storage_pop_array' ) ) {
	function kicker_storage_pop_array( $var_name, $key = '', $defa = '' ) {
		global $KICKER_STORAGE;
		$rez = $defa;
		if ( '' === $key ) {
			if ( isset( $KICKER_STORAGE[ $var_name ] ) && is_array( $KICKER_STORAGE[ $var_name ] ) && count( $KICKER_STORAGE[ $var_name ] ) > 0 ) {
				$rez = array_pop( $KICKER_STORAGE[ $var_name ] );
			}
		} else {
			if ( isset( $KICKER_STORAGE[ $var_name ][ $key ] ) && is_array( $KICKER_STORAGE[ $var_name ][ $key ] ) && count( $KICKER_STORAGE[ $var_name ][ $key ] ) > 0 ) {
				$rez = array_pop( $KICKER_STORAGE[ $var_name ][ $key ] );
			}
		}
		return $rez;
	}
}

// Inc/Dec array element with specified value
if ( ! function_exists( 'kicker_storage_inc_array' ) ) {
	function kicker_storage_inc_array( $var_name, $key, $value = 1 ) {
		global $KICKER_STORAGE;
		if ( ! isset( $KICKER_STORAGE[ $var_name ] ) ) {
			$KICKER_STORAGE[ $var_name ] = array();
		}
		if ( empty( $KICKER_STORAGE[ $var_name ][ $key ] ) ) {
			$KICKER_STORAGE[ $var_name ][ $key ] = 0;
		}
		$KICKER_STORAGE[ $var_name ][ $key ] += $value;
	}
}

// Concatenate array element with specified value
if ( ! function_exists( 'kicker_storage_concat_array' ) ) {
	function kicker_storage_concat_array( $var_name, $key, $value ) {
		global $KICKER_STORAGE;
		if ( ! isset( $KICKER_STORAGE[ $var_name ] ) ) {
			$KICKER_STORAGE[ $var_name ] = array();
		}
		if ( empty( $KICKER_STORAGE[ $var_name ][ $key ] ) ) {
			$KICKER_STORAGE[ $var_name ][ $key ] = '';
		}
		$KICKER_STORAGE[ $var_name ][ $key ] .= $value;
	}
}

// Call object's method
if ( ! function_exists( 'kicker_storage_call_obj_method' ) ) {
	function kicker_storage_call_obj_method( $var_name, $method, $param = null ) {
		global $KICKER_STORAGE;
		if ( null === $param ) {
			return ! empty( $var_name ) && ! empty( $method ) && isset( $KICKER_STORAGE[ $var_name ] ) ? $KICKER_STORAGE[ $var_name ]->$method() : '';
		} else {
			return ! empty( $var_name ) && ! empty( $method ) && isset( $KICKER_STORAGE[ $var_name ] ) ? $KICKER_STORAGE[ $var_name ]->$method( $param ) : '';
		}
	}
}

// Get object's property
if ( ! function_exists( 'kicker_storage_get_obj_property' ) ) {
	function kicker_storage_get_obj_property( $var_name, $prop, $default = '' ) {
		global $KICKER_STORAGE;
		return ! empty( $var_name ) && ! empty( $prop ) && isset( $KICKER_STORAGE[ $var_name ]->$prop ) ? $KICKER_STORAGE[ $var_name ]->$prop : $default;
	}
}
